#include "utils.h"

#define CHR_ERR 127
/*MSB=SEGH, LSB=SEGA*/
const byte charset[]={
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, //Special chars. Not implemented
    0x00, 0x86, 0x22, 0x00, 0x00, 0x00, 0x00, 0x20, 0x39, 0x0F, 0x63, 0x00, 0x00, 0x40, 0x80, 0x52,
    //      !     "     #     $     %     &     '     (     )     *     +     ,     -     .     /
    0x3F, 0x06, 0x5B, 0x4F, 0x66, 0x6D, 0x7D, 0x07, 0x7F, 0x6F, //0-9
    0x09, 0x00, 0x58, 0x48, 0x4C, 0x87, 0x00,
    //:     ;     <     =     >     ?     @
    0x77, 0x7C, 0x39, 0x5E, 0x79, 0x71, 0x3D, 0x74, 0x04, 0x0E, 0x75, 0x30, 0x37, 0x54, 0x5C, 0x73, 0x67, 0x50, 0x6D, 0x78, 0x1C, 0x2A, 0x6A, 0x36, 0x66, 0x5B,// A-Z
    0x39, 0x64, 0x0F, 0x23, 0x08, 0x02,
    //[     \     ]     ^     _     '
    0x77, 0x7C, 0x39, 0x5E, 0x79, 0x71, 0x3D, 0x74, 0x04, 0x0E, 0x75, 0x30, 0x37, 0x54, 0x5C, 0x73, 0x67, 0x50, 0x6D, 0x78, 0x1C, 0x2A, 0x6A, 0x36, 0x66, 0x5B,// a-z
    0x39, 0x06, 0x0F, 0x01, 0xFF
    //{     |     }     ~     DEL
};

byte getPrintableSize(const char* a);


void writeo(const char* a, sbyte start)
{
    byte i,j;
    signed char chr;
    
    if(start<0){
        start =  -start - getPrintableSize(a) -1;
    }
    start = _MIN(_MAX(start, 0), DISPLAYS-1); //Clipping
    
    for(i=start, j=0; (i<DISPLAYS) && (a[j] != '\0'); i++, j++){
        chr = a[j];
        if(chr == '.')
            display[--i] |= charset[chr]; //Put it on the last char
        else if(0<=chr) //cant be higher than 127 because char
            display[i] = charset[chr];
        else //All others chars
            display[i] = charset[CHR_ERR];
    }
}

byte getPrintableSize(const char* a)
{
    byte s = 0;
    char chr;
    
    while((chr = *(a++)) != '\0')
        if(chr != '.')
            s++;
    
    return s;
}